;; Following is functions for DataBag
;; Written by S.Sugou

(defun write-region-DataBag (write-bufferp)
; Buffer content is written when user types prefix-argument.
  (interactive "P")
  (catch 'bye
    (let ((DataBag-path "/usr/local/bin/openDataBag")
          (start (if write-bufferp (point-min) (region-beginning)))
          (end   (if write-bufferp (point-max) (region-end)))
          (msg (format "Writing %s to DataBag..." (if write-bufferp "buffer" "region"))))
      (unwind-protect
          (progn
            (if (and write-bufferp (not (y-or-n-p "Write buffer to DataBag ")))
                (throw 'bye nil))
            (setq cursor-in-echo-area t)
            (message msg)
            (call-process-region start end DataBag-path
                                 nil nil nil))
        (setq cursor-in-echo-area nil)
        (message "")))))

(defun write-region-DataBag (write-bufferp)
; Buffer content is written when user types prefix-argument.
; This function works correctly even if the computer on which Emacs runs is non-NeXT computer.
  (interactive "P")
  (catch 'bye
    (let* ((NeXT-host "osushi")
           (DataBag-path "/usr/local/bin/openDataBag")
           (running-on-NeXTp (string= (getenv "HOST") NeXT-host))
           (start (if write-bufferp (point-min) (region-beginning)))
           (end   (if write-bufferp (point-max) (region-end)))
           (cmd (if running-on-NeXTp
                    DataBag-path
                  (format "rsh %s %s" NeXT-host DataBag-path)))
           (msg (format "Writing %s to DataBag..." (if write-bufferp "buffer" "region"))))
      (unwind-protect
          (progn
            (if (and write-bufferp (not (y-or-n-p "Write buffer to DataBag ")))
                (throw 'bye nil))
            (setq cursor-in-echo-area t)
            (message msg)
            (call-process-region start end shell-file-name
                                 nil nil nil
                                 "-c" cmd))
        (setq cursor-in-echo-area nil)
        (message "")))))
